/*
filename :JoystickRx.C
author : fhn
date : 21-july-2018
MCU  : ATtiny13(A)

*/
#define NO 0
#define YES 1
#define RESET 2
#define ERROR -1

#define F_CPU	1000000UL


#define bSIG	0b00010000
#define DELY 95 //microsenconds

#include <avr/io.h>
#include <util/delay.h>

uint8_t outSIG[16] = {0,0b0110, 0b1001,0,0b1010,0b0010,0b1000,0,0b0101,0b0001,0b0100,0,0,0,0,0 };
//========================================================
void initPorts ( )
{
	DDRB = (~bSIG); 
}
//========================================================
int main ( )
{
	int cod = 0;
	int isStd =NO;
	int isRdy=NO;
	int pst=0;
	int los=0;
	int bits=0;

	_delay_ms(100);
	initPorts ( );
	_delay_ms(100);
	isStd=NO;
	while ( 1 )
	{
		
		pst = PINB & bSIG;

		isRdy = NO;
		if (pst==0)
		{
			los++;
			if (los==45) 
				{
				if (bits==10)
					{
					if ( (cod & 0b11111)==cod>>5)
						isRdy=YES;
					
					}
				}
			if (los>100)
			{
				los=50;
				isRdy=RESET;
			}
		}
		else if (isStd == YES && los>0)
		{
				if (los<5)
				{
					isRdy=ERROR; 
				}
				else
				{
					cod = (cod<<1);
					bits++;
					if (los>20)  
						cod |= 1; 
				}


				los=0;
		}
		else
		{
			isStd = YES;
			los=0;
		}

		if ( isRdy==YES ) 
			PORTB = outSIG[cod & 0b1111]; 

		if (isRdy!=NO)
		{
			cod=0;
			isStd = NO;
			bits=0;
			isRdy = NO;
		}

		_delay_us ( DELY );
	}
	return 0;
}
